# TOFU
# Copyright (C) 2005 Jean-Baptiste LAMY
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import cPickle as pickle, sets
from StringIO import StringIO

SAFE_MODULES = sets.Set(["__builtin__", "copy_reg", "sets", "tofu"])

def safe_module(module_name):
  SAFE_MODULES.add(module_name)
  
def find_global(module_name, class_name):
  if module_name in SAFE_MODULES:
    return getattr(__import__(module_name, None, None, [""]), class_name)
  else:
    raise pickle.UnpicklingError("Unsecure object for unpickling: %s.%s" % (module_name, class_name))
  
  
def loads(data):
  u = pickle.Unpickler(StringIO(data))
  u.find_global = find_global
  return u.load()
